#line 1 "C:/_MikroC/_MesProjets_MikroC/_IRC5/IRC5_18F26k22_150330.c"
#line 110 "C:/_MikroC/_MesProjets_MikroC/_IRC5/IRC5_18F26k22_150330.c"
const code char mesg0[]="Mikroc pro 6.50 18F26K22 Test IRC5  150215\n\r";
const code char mesg1[]="                    ";
const code char * Messages[]={mesg0,mesg1};


const char Libel0[]="Cmd ";
const char Libel1[]="Num ";
const char Libel2[]="Droite";
const char Libel3[]="Gauche";
const char Libel4[]="Vol.+ ";
const char Libel5[]="Vol.- ";
const char Libel6[]="OK";
const char Libel7[]="Menu  ";
const char Libel8[]="Mute  ";
const char Libel9[]="Osd   ";
const char Libel10[]="Haut  ";
const char Libel11[]="Bas   ";
const char Libel12[]="Clear ";
const char Libel13[]="Memo  ";
const char Libel14[]="Correct ";
const char Libel15[]="sleep ";
const char Libel16[]="Aigu +  ";
const char Libel17[]="Aigu -  ";
const char Libel18[]="point ";
const char Libel19[]="Channel >>";
const char Libel20[]="Channel <<";
const char *IRC5_Str[]={Libel0,Libel1,Libel2,Libel3,Libel4,Libel5,Libel6,Libel7,
 Libel8,Libel9,Libel10,Libel11,Libel12,Libel13,Libel14,
 Libel15,Libel16,Libel17,Libel18,Libel19,Libel20};



const char chaine0[]="                  ";
const char chaine1[]="Port comm 19200 ouvert";
const char chaine2[]="PROJET MikroC : IRC5_18F26K22.mcppi\r\n";
const char chaine3[]="ESC pour sortir\r\n";
const char chaine4[]="MARANTZ RC5200SR \r\n";
const char chaine5[]="                 \r\n";
const char chaine6[]="car recu :";
const char chaine7[]="                 \r\n";
const char chaine8[]="                 \r\n";
const char chaine9[]="   \r\n";
const char chaine10[]="  \r\n";
const char chaine11[]="IR TSOP36 Capture via IT sur RB0  \r\n";
const char chaine12[]="C:\_MikroC\_MesProjets_MikroC\_IRC5\IRC5_18F26k22_150330.c \r\n";

const char *RS_Str[]={chaine0,chaine1,chaine2,chaine3,chaine4,chaine5,chaine6,chaine7,
 chaine8,chaine9,chaine10,chaine11,chaine12};

typedef unsigned char byte ;
#line 190 "C:/_MikroC/_MesProjets_MikroC/_IRC5/IRC5_18F26k22_150330.c"
char Texte[ 63 ];
char CRam1[18];
char *txt=&Texte[0];

volatile char buffer1[ 63 ];
volatile int CptErr=0;
volatile unsigned char c1=0;
volatile Flag_Buffer;
volatile unsigned int i1,Index1=0;

unsigned int Count1;
unsigned char Flag_Timer1;


struct chbits {
 unsigned running:1;
 unsigned standby:1;
 unsigned Allume:1;
 unsigned Accumule:1;
 unsigned Blc:1;
 unsigned OneShot:1;
 unsigned Fill:1;
 unsigned Lcd:1;
 } Drapeaux;

unsigned short int i,j,k,l;
unsigned int dummy;
unsigned long M1;
float f1,f2;

unsigned long Volume;
int CptCars;

enum {
 IRC5_IDLE,
 IRC5_DECODING,
 IRC5_COMPLETED
} IRC5_state ;

unsigned char Fx[20];
unsigned int IRC5_times[32];
volatile int IR_Index;
volatile int IRC5_Index;
unsigned int IRC5_bits ;
 unsigned char  IRC5_bitCount ;
 unsigned char  IRC5_prevBit ;
 unsigned char  IRC5_shortPulses ;

volatile struct nbbits
{
 unsigned toggle : 1 ;
 unsigned device : 5 ;
 unsigned command : 6 ;
 unsigned received : 1 ;
} IR ;

volatile unsigned int time;

int EAn0,EAn1;
int N1;
unsigned char addr,donnee;


unsigned int Compteur;
char * valtxt;
unsigned int M;
unsigned long ML;


unsigned int dev, cmdx ;
unsigned int repeat ;
unsigned char last_toggle ;

unsigned int clk;
volatile char FLAG ;
volatile unsigned int cmd;

int nbit=0;

void Init_Hardware(void) ;
void Read_Msg_Eeprom( int depuis);
void Write_Msg_Eeprom( int Adr,const char * d1) ;
void Init_Timer0(void);
void Init_Timer1 (void);
void Init_Timer2 (void);
void CRLF(void) ;
void UART1_Write_CText(const char *txt);
#line 314 "C:/_MikroC/_MesProjets_MikroC/_IRC5/IRC5_18F26k22_150330.c"
void Interrupt() iv 0x0008 ics ICS_AUTO
{
 unsigned int time;
#line 351 "C:/_MikroC/_MesProjets_MikroC/_IRC5/IRC5_18F26k22_150330.c"
 if (INTCON.INT0IF==1)
 {


 INTCON2.INTEDG0 = ~INTCON2.INTEDG0 ;
 INTCON.INT0IF =0;
 time =TMR0L ;
 TMR0L=0;
 switch (IRC5_state)
 {

 case IRC5_IDLE :
 IRC5_bits = 1;
 IRC5_bitCount = 1;
 IRC5_shortPulses = 0;
 IRC5_prevBit = 1;
 IRC5_state = IRC5_DECODING;
 INTCON.TMR0IF = 0;
 INTCON.TMR0IE = 1;
 break ;


 case IRC5_DECODING :
 if ((time >  35 ) && (time <  176 ))
 {
 if (time <  104 )
 {
 IRC5_shortPulses ++ ;
 if (IRC5_shortPulses == 2)
 {
 IRC5_bits <<= 1;
 IRC5_bits |= IRC5_prevBit;
 IRC5_bitCount ++ ;
 IRC5_shortPulses = 0;
 }
 } else {
 IRC5_prevBit = 1- IRC5_prevBit;
 IRC5_bits <<= 1;
 IRC5_bits |= IRC5_prevBit;
 IRC5_bitCount ++ ;
 IRC5_shortPulses = 0;
 }

 if (IRC5_bitCount ==  14 )
 {
 IRC5_state = IRC5_COMPLETED;
 INTCON2.INTEDG0 = 0;
 INTCON.TMR0IE = 0;
 TMR0L=0;

 }
 } else {
 IRC5_state = IRC5_IDLE;
 INTCON2.INTEDG0 = 0;


 }
 break ;


 case IRC5_COMPLETED :
 INTCON2.INTEDG0 = 0;
 IR.toggle = ((IRC5_bits>>11) & 0x01) ? 0 : 1 ;
 IR.device = (IRC5_bits>>6) & 0b00011111 ;
 IR.command= (IRC5_bits & 0b00111111) ;
 IR.received = 1 ;
 IRC5_state = IRC5_IDLE ;
 break ;

 }
 }

 if ( (RCIE_bit) && ( RCIF_bit))
 {

 if (RCSTA.OERR==1)
 {
 RCSTA.CREN = 0 ;
 c1 = RCREG;
 RCSTA.CREN = 1 ;
 CptErr++;
 }
 if(RCSTA.FERR==1 )
 {
 RCSTA.SPEN = 0 ;
 RCSTA.SPEN= 1 ;
 CptErr++;
 c1 = RCREG;
 }
 c1 = RCREG;
 if (c1== 13 )
 {
 Flag_Buffer=1;

 buffer1[i1]=0;
 Index1=i1;
 i1=0;
 c1=0;
 }
 else
 {
 buffer1[i1]=c1;
 Index1=i1;
 i1++;
 }
 PIR1.RCIF=0 ;
 }

 if (INTCON.TMR0IF==1)
 {
 if (IRC5_state == IRC5_DECODING)
 {
 IRC5_state = IRC5_IDLE;
 INTCON2.INTEDG0 = 0;
 INTCON.TMR0IE = 0;
 }
 INTCON.TMR0IF = 0;
 }


}



void strConstRamCpy(unsigned char *dest, const code char *source)
 {
 while (*source)*dest++ = *source++ ;
 *dest = 0 ;
}

void CRLF()
{
 UART1_Write( 13 );
 UART1_Write( 10 );
}

void UART1_Write_CText(const char *txt)
 {
 while (*txt)
 UART1_Write(*txt++);
}

void Write_Msg_Eeprom(int Adr,const char * d1)
{ int i1 ,i;
 char c1;
 i1=Adr;
 do
 {
 c1=*d1;
 EEPROM_Write(Adr,c1);
 if ( c1==0) break;
 if ( i1>1023) break;
 Delay_ms(5);
 i1++;
 }
 while (i!=0) ;
 }


void Read_Msg_Eeprom( int debut)
{ int i1 ,i;
 i1=debut;
 do
 {
 i = EEPROM_Read(i1);
 if (( i==0) || (i==0xFF)) break;
 if ( i1>1023) break;
 UART1_Write(i);

 Delay_ms(5);
 i1++;
 }
 while (i!=0) ;
 }


 void Decompile_byte( unsigned char  un) {
char masque;
 masque = 128;
 while (masque > 0 ) {
 if (un & masque)
 UART1_Write(49);
 else
 UART1_Write(48);
 masque >>= 1;
 }

}

void Octet2Hex(char number)
{
char high,low;

 high = ((number & 0xF0) >> 4) + 48;
 if (high > '9')
 high =high + 7;

 low = (number & 0x0F) + 48;
 if (low > '9')
 low += 7;
 UART1_Write(high);
 UART1_Write(low);
 UART1_Write('h');
 }


void Write_Word(unsigned int M,char Sign)
{


unsigned int i,k,l;
unsigned long L1;
unsigned char valtxt[8];

 if (Sign>1) return;
 if (Sign==0)
 { L1=(long)M;
 LongWordToStr(L1,valtxt);
 }
 else WordToStr(M,valtxt);
 if (Drapeaux.Fill==1)
 {
 k=strlen(valtxt);
 for (i=0;i<k;i++)valtxt[4+Sign-i]=valtxt[k-i-1];
 for (i=0;i<(5+Sign-k);i++)
 {if (Drapeaux.Blc==1) valtxt[i]='0'; else valtxt[i]=' ';}
 }
 valtxt[5+Sign]=0;
 UART1_Write_Text(valtxt);
}

 void Tempo(long val)
{
while(val>0)
{
val--;
}
}


void Float2Ascii (float x, unsigned char *str,char precision)
{


 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;

 if ( x < 0)
 {
 *str++ = '-';
 x = -x;
 }

 if (x > 0.0) while (x < 1.0)
 {
 x *= 10.0;
 ie--;
 }
 while (x >= 10.0)
 {
 x = x/10.0;
 ie++;
 }

 ndig += ie;


 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
 *str++ = '0'; *str++ = '.';
 if (ndig < 0) ie = ie-ndig;
 for (i = -1; i > ie; i--) *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
 k = x;
 *str++ = k + '0';
 if (i == ie ) *str++ = '.';
 x -= (y=k);
 x *= 10.0;
 }
 *str = '\0';
}

void PrintHandler(char c)
 {
 UART1_Write(c);
}


 void Init_Timer0(void)
 {
 T0CON=0;
 T0CON.T08BIT=1;
 T0CON.PSA=0;
 T0CON.T0PS2=1;
 T0CON.T0PS1=0;
 T0CON.T0PS0=0;
 TMR0H= 0x00;
 TMR0L= 0x00;
 T0CON.TMR0ON=0;
 INTCON.TMR0IF=0;
 TMR0IP_bit=1;
 INTCON.TMR0IE=0;
 }

void Init_Timer1(void)
 {
 T1CON=0;

 T1CON.TMR1CS0=0;
 T1CON.TMR1CS1=0;
 T1CKPS1_bit=1;
 T1CKPS0_bit=1;
 T1GCON=0;
 TMR1H= 0x0B;
 TMR1L= 0xDB;


 Count1=0;
 Flag_Timer1=0;
 PIR1.TMR1IF=0;
 PIE1.TMR1IE=0;
 TMR1ON_bit=0;
}


void Init_ADC()
 {

 ADCON0.ADON=1;
 ADCON1.TRIGSEL=0 ;
 ADCON2.ADFM=1;
 ADCON2.ACQT2=1;
 ADCON2.ACQT1=1;
 ADCON2.ACQT0=0;
 ADCON2.ADCS1=1;
 ADCON2.ADCS2=0;
 ADCON2.ADCS0=0;

 ADCON1.PVCFG1=0;
 ADCON1.PVCFG0=0;






 ADCON1.NVCFG1=0;
 ADCON1.NVCFG0=0;
 }

 void Init_Hardware()
{
 PORTB = 0x00;
 TRISB = 0xFF;
 ANSELB=0;

 PORTA = 0b00001111;
 ANSELA=0;


 TRISA = 0b00001111 ;
 PORTA=0;

 PORTC = 0x00;
 ANSELC=0;
 TRISC = 0xFF;
 TRISC.TRISC3 = 1;
 TRISC.TRISC4 = 1;
 TRISC.TRISC7 = 1;
 TRISC.TRISC6 = 0;

 SLRCON=0;
 }



unsigned int lecture_trame_rc5()
{ unsigned int i,val;
 if ( PORTB.F0 ==1)
 {
 while ( PORTB.F0 == 1){};

 Delay_us(220);
 for (i=0;i<14;i++)
 {
 buffer1[i] = ! PORTB.F0 ;

 Delay_us(875);
 }

 val=buffer1[13]+2*buffer1[12]+4*buffer1[11]+8*buffer1[10]+16*buffer1[9]+32*buffer1[8];
 }
 return (val);
 }

void Beep(long ton)
{


int i=0;
 while(i<100)
 {
  LATA.F5 =0;
 Tempo(ton);
  LATA.F5 =1;
 Tempo(ton);
 i++;
 }
}



void main()
{
 Delay_ms(1000);
 Init_Hardware();
 Delay_ms(1000);

 txt=&Texte[0];




 UART1_Init(9600);
 Delay_ms(100);


 CRLF();



 UART1_Write_CText(chaine2);
 UART1_Write_CText(chaine12);
 UART1_Write_CText(chaine11);
 UART1_Write_CText(chaine4);
 UART1_Write_CText(chaine1);
 CRLF();
 Delay_ms(1000);
 Read_Msg_Eeprom(0x0010) ;
 clk = Clock_kHz();
 WordToStr(clk , txt);
 UART1_Write_Text(txt);
 UART1_Write_CText(" Khz \r\n");

 CRLF();
 Read_Msg_Eeprom(0x0020) ;
 UART1_Write('#');
 CRLF();
 delay_us(2000000);
 CRLF();
 UART1_Write ('*');
 CRLF();

 IRC5_state = IRC5_IDLE ;
 for (i=0; i< sizeof (IRC5_times); i ++) IRC5_times[i] = 0 ;

 Init_Timer0() ;

 INTCON3=0;
 PIE1=0;
 PIE2=0;
 INTCON3=0;
 RCON.IPEN=1;
 IR_Index=0;


 INTCON.T0IE = 0;
 INTCON2.INTEDG0 = 0;
 INTCON.INT0IF = 0;

 Volume=0;
 CptCars=0;
 Drapeaux.Accumule=0;
 Fx[0]=0;
 f1=0.0;
 IR.received = 0 ;
 last_toggle = 2 ;

 Read_Msg_Eeprom(0x0030) ;
 CRLF();

 T0CON.TMR0ON=1;
 INTCON.PEIE = 1;
 INTCON.TMR0IE = 1;
 INTCON.INT0IE = 1;
 INTCON.GIE = 1;




 do
 {


 if (IR.received==1)
 {
  LATA.F4 =0;
 INTCON.INT0IE=0 ;
 INTCON.GIE = 0;
 dev = IR.device ;
 cmd = IR.command;
 IR.received = 0 ;
 if (last_toggle == IR.toggle)
 {
 repeat ++ ;
 } else
 {
 repeat = 0 ;
 last_toggle = IR.toggle;
 }
#line 879 "C:/_MikroC/_MesProjets_MikroC/_IRC5/IRC5_18F26k22_150330.c"
 switch (cmd)
 {

 case 0:
 case 1:
 case 2:
 case 3:
 case 4:
 case 5:
 case 6:
 case 7:
 case 8:
 case 9:

 UART1_Write_CText(IRC5_Str[1]);
 UART1_Write( 9 );UART1_Write(cmd+48);
 UART1_Write( 9 );
 if (CptCars==0)Drapeaux.Accumule=1;
 if (Drapeaux.Accumule)
 {
 Fx[CptCars]=cmd+48;
 if (CptCars<16)CptCars++;
 Fx[CptCars]=0;
 UART1_Write_Text(Fx);
 }
 break;
 case 13:
 UART1_Write_CText(IRC5_Str[8]);

 break ;
 case 15:
 UART1_Write_CText(IRC5_Str[9]);
 break ;
 case 16:
 Texte[0]=0;txt=&Texte[0];
 UART1_Write_CText(IRC5_Str[4]);
 UART1_Write( 9 );

 if(Volume<2000000000)
 {
 Volume++;
 Texte[0]=0;txt=&Texte[0];
 LongWordToStr(Volume,txt);

 UART1_Write_Text(txt);
 }
 break ;
 case 17:
 Texte[0]=0;txt=&Texte[0];
 UART1_Write_CText(IRC5_Str[5]);
 UART1_Write( 9 );

 if(Volume>0)
 {
 Volume--;
 Texte[0]=0;txt=&Texte[0];
 LongWordToStr(Volume,txt);

 UART1_Write_Text(txt);
 }
 break ;
 case 23:
 if(dev==0)
 {
 UART1_Write_CText(IRC5_Str[6]);
 UART1_Write( 9 );
 if ((CptCars>0) && (Drapeaux.Accumule==1))
 {
 f1=atof(Fx);
 UART1_Write_Text(Fx);
 Drapeaux.Accumule=0;
 CptCars=0;
 }
 }
 break ;
 case 24:
 UART1_Write_CText(IRC5_Str[16]);
 break ;
 case 25:
 UART1_Write_CText(IRC5_Str[17]);
 break ;
 case 28:
 UART1_Write_CText(IRC5_Str[10]);
 break ;
 case 29:
 UART1_Write_CText(IRC5_Str[11]);
 break ;
 case 32:
 UART1_Write_CText(IRC5_Str[19]);
 break ;
 case 33:
 UART1_Write_CText(IRC5_Str[20]);
 break ;
 case 34:
 UART1_Write_CText(IRC5_Str[14]);
 if (CptCars>0)
 {
 CptCars--;
 Fx[CptCars]=0;
 UART1_Write_Text(Fx);
 }
 break ;
 case 38:
 UART1_Write_CText(IRC5_Str[15]);
 break ;
 case 41:
 UART1_Write_CText(IRC5_Str[18]);

 if ((CptCars>1)&& (Drapeaux.Accumule==1))
 {
 Fx[CptCars]='.';
 if (CptCars<16)CptCars++;
 Fx[CptCars]=0;
 UART1_Write_Text(Fx);
 }
 break ;
 case 43:
 UART1_Write_CText(IRC5_Str[2]);
 break ;
 case 44:
 UART1_Write_CText(IRC5_Str[3]);
 break ;
 case 46:
 UART1_Write_CText(IRC5_Str[7]);
 break ;
 case 49:
 UART1_Write_CText(IRC5_Str[12]);
 CptCars=0; Drapeaux.Accumule=0;Fx[0]=0;f1=0;
 break ;
 case 60:
 UART1_Write_CText(IRC5_Str[13]);
 UART1_Write( 9 );




 Float2Ascii (f1,txt,3);
 UART1_Write_Text(txt); UART1_Write( 9 );
 M1=(long)(ceil(f1)) ;
 UART1_Write_CText(" M1= ");
 txt=&Texte[0];
 LongWordToStr(M1, txt);
 UART1_Write_Text(txt); UART1_Write('L');

 break ;
 default:
 break;
 }






 CRLF();
 INTCON.INT0IE=0 ;
 if (cmd<10)Beep(60); else Beep(120);

 INTCON.INT0IF = 0;
 INTCON.INT0IE=1 ;
  LATA.F4 =0;
 INTCON.GIE = 1;
 }
 }while(1);
}
